local frame = CreateFrame("Frame")
local last_warning = time() - 30

function frame.UNIT_HEALTH(self, unit)
	if InCombatLockdown() and UnitIsUnit(unit, "player") and UnitHealth("player") < (UnitHealthMax("player") / 2) and time() - last_warning > 5 then

		PlaySoundFile('Sound/Creature/Murloc/mMurlocAggroOld.wav')
		self:flash()

		last_warning = time()
	end
end

-- Shamelessly copied from Omen - thanks!
function frame:flash()
	if not self.FlashFrame then
		local flasher = CreateFrame("Frame", "ProcodileFlashFrame")
		flasher:SetToplevel(true)
		flasher:SetFrameStrata("FULLSCREEN_DIALOG")
		flasher:SetAllPoints(UIParent)
		flasher:EnableMouse(false)
		flasher:Hide()
		flasher.texture = flasher:CreateTexture(nil, "BACKGROUND")
		flasher.texture:SetTexture("Interface\\FullScreenTextures\\LowHealth")
		flasher.texture:SetAllPoints(UIParent)
		flasher.texture:SetBlendMode("ADD")
		flasher:SetScript("OnShow", function(self)
			self.elapsed = 0
			self:SetAlpha(0)
		end)
		flasher:SetScript("OnUpdate", function(self, elapsed)
			elapsed = self.elapsed + elapsed
			if elapsed < 2.6 then
				local alpha = elapsed % 1.3
				if alpha < 0.15 then
					self:SetAlpha(alpha / 0.15)
				elseif alpha < 0.9 then
					self:SetAlpha(1 - (alpha - 0.15) / 0.6)
				else
					self:SetAlpha(0)
				end
			else
				self:Hide()
			end
			self.elapsed = elapsed
		end)
		self.FlashFrame = flasher
	end

	self.FlashFrame:Show()
end
  
frame:RegisterEvent('UNIT_HEALTH')
frame:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)

